--- /storage/sc/cam.h
+++ /storage/sc-nas/cam.h
@@ -16,6 +16,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  * Or, point your browser to http://www.gnu.org/copyleft/gpl.html
  */
+
+#define LIBDVBCSA
 
 #ifndef ___CAM_H
 #define ___CAM_H
@@ -241,10 +243,17 @@
 class cDeCSA {
 private:
   int cs;
+  #ifndef LIBDVBCSA
   unsigned char **range, *lastData;
+  void *keys[MAX_CSA_IDX];
+  #else
+  struct dvbcsa_bs_batch_s *cs_tsbbatch_even;
+  struct dvbcsa_bs_batch_s *cs_tsbbatch_odd;
+  struct dvbcsa_bs_key_s *cs_key_even[MAX_CSA_IDX];
+  struct dvbcsa_bs_key_s *cs_key_odd[MAX_CSA_IDX];
+  #endif
   unsigned char pidmap[MAX_CSA_PIDS];
-  void *keys[MAX_CSA_IDX];
-  unsigned int even_odd[MAX_CSA_IDX], flags[MAX_CSA_IDX];
+unsigned int even_odd[MAX_CSA_IDX], flags[MAX_CSA_IDX];
   cMutex mutex;
   cCondVar wait;
   cTimeMs stall;
